"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');

var _require = require('react-redux'),
    connect = _require.connect;

var _require2 = require('react-router-config'),
    matchRoutes = _require2.matchRoutes,
    renderRoutes = _require2.renderRoutes;

var _require3 = require('./actions'),
    fetchPageDataAction = _require3.fetchPageData,
    handleErrorAction = _require3.handleError,
    handleOfflineAction = _require3.handleOffline;

function mstp(state, ownProps) {
  var location = state.router.location;
  var _state$pageLoader = state.pageLoader,
      error = _state$pageLoader.error,
      isOffline = _state$pageLoader.isOffline,
      isFetching = _state$pageLoader.isFetching,
      renderedRoute = _state$pageLoader.renderedRoute;
  var routes = ownProps.routes;
  var matchRouted = matchRoutes(routes, location.pathname)[0].route;
  var isStoreValid = matchRouted.path === renderedRoute.path;
  var isAppShell = renderedRoute.path === '/app-shell';
  var AppShellPage = routes.filter(function (route) {
    return route.path === '/app-shell';
  })[0].component;
  return {
    AppShellPage: AppShellPage,
    isFetching: isFetching,
    isAppShell: isAppShell,
    isStoreValid: isStoreValid,
    location: location,
    renderedRoute: renderedRoute,
    isOffline: isOffline,
    errorOccured: !!error
  };
}

function mdtp(dispatch) {
  return {
    fetchPageData: function fetchPageData() {
      return dispatch(fetchPageDataAction.apply(void 0, arguments));
    },
    handleError: function handleError() {
      return dispatch(handleErrorAction.apply(void 0, arguments));
    },
    handleOffline: function handleOffline() {
      return dispatch(handleOfflineAction.apply(void 0, arguments));
    }
  };
}

var PageLoader =
/*#__PURE__*/
function (_React$Component) {
  _inherits(PageLoader, _React$Component);

  function PageLoader() {
    _classCallCheck(this, PageLoader);

    return _possibleConstructorReturn(this, (PageLoader.__proto__ || Object.getPrototypeOf(PageLoader)).apply(this, arguments));
  }

  _createClass(PageLoader, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.errorOccured || this.props.isStoreValid) {
        return;
      } // store is not valid
      // eg app-shell has been returned from request


      this._navigatedTo(this.props.location);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var navigationChanged = nextProps.location !== this.props.location;

      if (navigationChanged) {
        this._navigatedTo(nextProps.location);
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      var navigationChanged = nextProps.location !== this.props.location;
      return !navigationChanged && !nextProps.isFetching;
    }
  }, {
    key: "_navigatedTo",
    value: function _navigatedTo(location) {
      var _props = this.props,
          routes = _props.routes,
          handleError = _props.handleError,
          handleOffline = _props.handleOffline;
      var matchedRoutes = matchRoutes(routes, location.pathname);
      Promise.all([this._fetchData(matchedRoutes), this._loadComponents(matchedRoutes)]).catch(function (error) {
        // js / css could fail
        // data loading could fail
        if (window.navigator.onLine) {
          handleError({
            error: error
          });
        } else {
          handleOffline();
        }
      }).then(function () {
        window.scrollTo(0, 0);
      });
    }
  }, {
    key: "_loadComponents",
    value: function _loadComponents(matchedRoutes) {
      var promises = matchedRoutes.map(function (_ref) {
        var route = _ref.route;
        return route.component.preload ? route.component.preload() : Promise.resolve();
      });
      return Promise.all(promises);
    }
  }, {
    key: "_fetchData",
    value: function _fetchData(matchedRoutes) {
      var fetchPageData = this.props.fetchPageData;
      var promises = matchedRoutes.map(function (_ref2) {
        var route = _ref2.route,
            match = _ref2.match;
        return route.fetcher ? fetchPageData({
          route: route,
          match: match
        }) : Promise.resolve();
      });
      return Promise.all(promises);
    }
  }, {
    key: "render",
    value: function render() {
      var _props2 = this.props,
          routes = _props2.routes,
          isStoreValid = _props2.isStoreValid,
          isOffline = _props2.isOffline,
          isAppShell = _props2.isAppShell,
          errorOccured = _props2.errorOccured,
          AppShellPage = _props2.AppShellPage,
          OfflinePage = _props2.OfflinePage,
          ErrorPage = _props2.ErrorPage;

      if (isOffline) {
        return React.createElement(OfflinePage, null);
      }

      if (errorOccured) {
        return React.createElement(ErrorPage, null);
      }

      if (!isStoreValid && isAppShell) {
        // app-shell booting...
        // we can't yet render the location, yet.
        return React.createElement(AppShellPage, null);
      }

      return renderRoutes(routes);
    }
  }]);

  return PageLoader;
}(React.Component);

module.exports = connect(mstp, mdtp)(PageLoader);