"use strict";

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _require = require('./actions'),
    ACTION_TYPES = _require.ACTION_TYPES;

var INITIAL_STATE = {
  isFetching: false,
  data: {},
  renderedRoute: {}
};

function handleFetchPageData(state, action) {
  return _objectSpread({}, state, {
    isFetching: true,
    isOffline: false
  });
}

function handleUpdatePageData(state, action) {
  return _objectSpread({}, state, {
    isFetching: false,
    renderedRoute: action.route,
    data: action.data
  });
}

function handleError(state, action) {
  return _objectSpread({}, state, {
    isFetching: false,
    error: action.error
  });
}

function handleOfflineMode(state, action) {
  return _objectSpread({}, state, {
    isFetching: false,
    isOffline: true
  });
}

module.exports = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case ACTION_TYPES.FETCH_PAGE_DATA:
      return handleFetchPageData(state, action);

    case ACTION_TYPES.UPDATE_PAGE_DATA:
      return handleUpdatePageData(state, action);

    case ACTION_TYPES.ERROR_OCCURED:
      return handleError(state, action);

    case ACTION_TYPES.OFFLINE_MODE:
      return handleOfflineMode(state, action);

    default:
      return state;
  }
};

module.exports.INITIAL_STATE = INITIAL_STATE;